import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;

/**
 * A simple class designed to represent a collection of
 * applet parameters, with convenience methods to set
 * parameters, remove parameters and list parameter values.
 * 
 * @author Davin McCall
 * @version 1.0
 */
public class AppletParams extends HashMap
{
    public AppletParams()
    {
        // nothing to do
    }
    
    /**
     * Add or modify a parameter
     * 
     * @param param  The name of the parameter to add or set
     * @param value  The value to set the parameter to
     */
    public void setParam(String param, String value)
    {
        put(param, value);
    }
    
    /**
     * Get a parameter value
     * 
     * @param param  The name of the parameter whose value to get
     * @return  The parameter value, or null if the parameter is undefined
     */
    public String getParam(String param)
    {
        return (String) get(param);
    }
    
    /**
     * Remove a parameter
     * 
     * @param param  The name of the parameter to remove
     */
    public void removeParam(String param)
    {
        remove(param);
    }
    
    /**
     * List the defined parameters on the terminal.
     */
    public void listParams()
    {
        System.out.println("Defined parameters");
        System.out.println("--------------------");
        
        Iterator i = entrySet().iterator();
        if (! i.hasNext())
            System.out.println("No parameters defined.");
            
        while (i.hasNext()) {
            Map.Entry entry = (Map.Entry) i.next();
            System.out.println((String) entry.getKey() + " = " + entry.getValue());
        }
        System.out.println();
    }
}
