/*
 * Borlands Applet - like applet only better
 *
 * @author Jeff Borland
 * @version 11/15
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.Scanner;
import java.applet.*;
import java.io.File;
import javax.imageio.ImageIO;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.Media;
import javafx.util.Duration;

public abstract class BFrame extends JFrame implements MouseListener, MouseMotionListener,ActionListener,KeyListener,Runnable
{
    int x=0;
    BufferedImage layerBase;
    BufferedImage layerSet;  
    BufferedImage layerTemp;  
    Color backgroundColor=Color.white;
    boolean isAnimation=false;
    LayoutManager theLayout=new FlowLayout();
    HashMap<String,AudioClip> allSounds = new HashMap<String,AudioClip>();
    boolean noDrawing=false;
    MediaPlayer p;

    public void init()
    {       
        addMouseListener(this);
        addMouseMotionListener(this);
        addKeyListener(this);
        setFocusable(true);

        Container screen = getContentPane();
        screen.setBackground(Color.white);
        screen = getContentPane();

        screen.setLayout (new FlowLayout() );
        initialize();

        //below is for our offscreen buffer image.  Make it as large 
        layerBase = new BufferedImage(2000, 2000, BufferedImage.TYPE_INT_ARGB);   
        layerSet = new BufferedImage(2000, 2000, BufferedImage.TYPE_INT_ARGB);   
        layerTemp = new BufferedImage(2000, 2000, BufferedImage.TYPE_INT_ARGB);  
        this.addWindowListener(new WindowAdapter(){
                public void windowClosing(WindowEvent e){                    
                        System.exit(0);//cierra aplicacion
                        //Platform.exit();
                }
            });
    }

    public void initialize(){

    }

    public void setScreenLayout(LayoutManager manager)
    {
        theLayout=manager;
        Container screen = getContentPane();
        screen.setLayout (theLayout);
    }

    public void setBackgroundColor(Color c)
    {
        Container screen = getContentPane();
        screen.setBackground(c);
        backgroundColor=c;
    }

    public void setBackgroundImage(String filename)
    {
        setContentPane(new ImagePanel(filename));
        Container screen = getContentPane();

        screen.setLayout (new FlowLayout() );
    }

    public void setBackgroundImage(String filename,double scale)
    {
        setContentPane(new ImagePanel(filename,scale));
        Container screen = getContentPane();

        screen.setLayout (new FlowLayout() );
    }    
    
    public void setBackgroundImage(String filename,int x, int y)
    {
        setContentPane(new ImagePanel(filename,x,y));
        Container screen = getContentPane();

        screen.setLayout (new FlowLayout() );
    }    

    public void addMenuListeners(JMenuBar menu){
        MenuElement[] topLevelElements = menu.getSubElements();
        //Get top level elements--> FileMenu etc
        for(MenuElement menuElement: topLevelElements)
        {
            MenuElement[] subElements = menuElement.getSubElements();
            //get the child elements which are of type JPopupMenu
            for(MenuElement subElement:subElements)
            {
                //This is the popuMenu which contains child elements
                //System.out.println(subElement.toString());
                if(subElement instanceof JPopupMenu)
                {
                    //show child elements
                    for(MenuElement childMenuItem:subElement.getSubElements())
                    {
                        //New and Save here ...
                        //System.out.println("ChildMenu Name=>" + childMenuItem.getComponent().getName());
                        ((JMenuItem)(childMenuItem.getComponent())).addActionListener(this);
                        
                    }
                }
                else
                {
                    //display names directly
                    //echo (
                }
            }
        }
    }

    public BufferedImage getLayerSet(){
        return layerSet;
    }
    
    public void addItem(Component c)
    {
        Container screen = getContentPane();
        if (c instanceof JMenuBar)
        {
            this.setJMenuBar((JMenuBar)c);     
            addMenuListeners((JMenuBar)c);
        }
        else{
            screen.add(c);
            if (c instanceof JButton)
                ((JButton) c).addActionListener(this);  
        }
    }    

    public void addItem(JPanel panel, Component c)
    {

        panel.add(c);
        if (c instanceof JButton)
            ((JButton) c).addActionListener(this);  
    } 

    public void addPanel(Component c, String direction)
    {
        Container screen = getContentPane();
        //  screen.setLayout(new BorderLayout());
        screen.add(c,direction);
    }               

    public void drawImage(String filename,int x,int y)
    {
        try
        {
            Graphics oG=layerSet.getGraphics();
            Image img = javax.imageio.ImageIO.read(this.getClass().getResource(filename));
            oG.drawImage(img,x,y,null);
            drawScreen();
        }
        catch (Exception e){System.out.println("error finding image file");}
    }
    
    public void drawImageTemp(String filename,int x,int y)
    {
        try
        {
            Graphics oG=layerTemp.getGraphics();
            Image img = javax.imageio.ImageIO.read(this.getClass().getResource(filename));
            oG.drawImage(img,x,y,null);
            drawScreen();
        }
        catch (Exception e){System.out.println("error finding image file");}
    }    

    public void drawImage(String filename,int x,int y,double scale)
    {
        try
        {
            Graphics oG=layerSet.getGraphics();
            Image img = javax.imageio.ImageIO.read(this.getClass().getResource(filename));
            int w = img.getWidth(null);
            int h = img.getHeight(null);
            oG.drawImage(img,x,y,(int)(w*scale),(int)(h*scale),null);
            drawScreen();
        }
        catch (Exception e){System.out.println("error finding image file");}
    }

    public void playMP3(String fileName) {
        new javafx.embed.swing.JFXPanel();
        try
        {        
            String uriString = this.getClass().getResource(fileName).toURI().toString();
            //System.out.println(uriString);
            Media m=new Media(uriString);
            p=new MediaPlayer(m);
            p.play();
        }
        catch (Exception e){System.out.println("error finding sound file"+e);}
    }

    public void stopMP3() {
        try
        {     
            p.stop();
        }
        catch (Exception e){System.out.println("error stopping sound file"+e);}
    }    
    
    public void loopMP3(String fileName) {
        new javafx.embed.swing.JFXPanel();
        try
        {        
            String uriString = this.getClass().getResource(fileName).toURI().toString();            
            Media m=new Media(uriString);
            p=new MediaPlayer(m);
            p.setOnEndOfMedia(new Runnable() {
                    public void run() {
                        p.seek(Duration.ZERO);
                    }
                });
            p.play();

           
        }
        catch (Exception e){System.out.println("error finding sound file");}
    }
    public void playSound(String filename)
    {
        if (allSounds.containsKey(filename))
            allSounds.get(filename).play();
        else
        {
            try
            {
                AudioClip  clip = Applet.newAudioClip(this.getClass().getResource(filename));
                allSounds.put(filename,clip);
                clip.play();
            }
            catch (Exception e){
                System.out.println("trouble with loading sound");
            }
        }

    }

    public void paint(Graphics g)
    {
        if (layerSet!=null && noDrawing==false)
        {
            super.paint(layerBase.getGraphics());
            Graphics oG=getG();
            //super.paint(oG);
            paintScreen(oG);           

            drawScreen();
        }
        else 
            drawScreen();
    }

    public void clearScreen()
    {
        //layerSet = new BufferedImage(2000, 2000, BufferedImage.TYPE_INT_RGB);  
        Graphics oG=layerSet.getGraphics();
        super.paint(oG);
        layerTemp = new BufferedImage(2000, 2000, BufferedImage.TYPE_INT_ARGB); 
        drawScreen();
    }

    public void paintScreen(Graphics g){
    }

    public Graphics getG()
    {        
        Graphics oG=layerSet.getGraphics();
        //super.paint(oG); 
        return oG;

    }

    public Graphics getTempG()
    {
        layerTemp = new BufferedImage(2000, 2000, BufferedImage.TYPE_INT_ARGB); 
        Graphics oT=layerTemp.getGraphics();
        return oT;
    }    

    public void drawScreen(){
        Graphics g=getGraphics();    
        if (g!=null)
        {
            //Now I create another buffergraphics and draw the 2 layers on top of each other
            //then i add it to g, the screen.  This minimizes flickering.
            BufferedImage layerAll = new BufferedImage(2000, 2000, BufferedImage.TYPE_INT_RGB);  

            Graphics layerAllGraphics = layerAll.getGraphics();
            super.paint(layerAllGraphics);
            //layerAllGraphics.drawImage(layerBase,0,0,this);
            if (noDrawing==false){
                layerAllGraphics.drawImage(layerSet,0,0,this);
                layerAllGraphics.drawImage(layerTemp,0,0,this); 
            }
            g.drawImage(layerAll,0,0,this);
        }

        /*
        else if (g!=null)
        {
        super.paint(g);
        g.drawImage(layerTemp,0,0,this); 
        }*/
        //            g.drawImage(offScreen,0,0,this); 
        //else echo ("not rendering screen");
    }

    //This is the method that will be called if a key is pressed
    //It is neccessary if you are using getKeyCode()
    public void keyPressed(KeyEvent e)
    {
        /*
        char theChar=e.getKeyChar();
        int theCode=e.getKeyCode();    */   
    }

    //This is the method that will be called if a key is released
    //It is unneccessary to use this method, but you must include it
    public void keyReleased(KeyEvent e)
    {  
    }

    //This is the method that will be called if a key is typed, however you cant use getKeyCode, so
    // you are better to use keyPressed
    public void keyTyped(KeyEvent e)
    {    
    }

    //when someone presses the mouse button
    public void mousePressed(MouseEvent e)
    {     
        int x=e.getX();
        int y=e.getY();
    }

    //when someone releases the mouse button
    public void mouseReleased(MouseEvent e)
    {     

    }

    // when the mouse enters the applet
    public void mouseEntered(MouseEvent e)
    {     

    }

    //when the mouse leaves the applet
    public void mouseExited(MouseEvent e)
    {     

    }

    //when the mouse button is clicked
    public void mouseClicked(MouseEvent e)
    {
        requestFocus(); //this bring the focus make to the main progra

    }

    //the mouse button is pressed and the mouse makes a significantly large movement
    public void mouseDragged(MouseEvent e)
    {

    }

    //the mouse makes a significantly large movement
    public void mouseMoved(MouseEvent e)
    {
    }

    public void actionPerformed(ActionEvent thisEvent)
    {
        Object source = thisEvent.getSource();
        buttonPressed((Component)source);
        /*if (source == l)
        {

        }
         */
        requestFocus();
    }

    public void buttonPressed(Component source){}

    public int findRandom (int start, int end)
    {
        int multiplier = end-start+1;
        int random = (int) (Math.random()*multiplier)+start;
        return random;
    }

    public Color findRandomColor ()
    {
        int red= (int)(256 * Math.random());
        int green= (int)(256 * Math.random());
        int blue= (int)(256 * Math.random());
        Color randomColor=new Color(red,green,blue);
        return randomColor;
    } 

    public void update(Graphics g)
    {

    }

    public void pause(int ms)
    {
        stop();
        try{
            Thread.sleep(ms);
        }
        catch (Exception e){}
        start();
    }

    public void updateIt()
    {

        update(getTempG());
        //layerTemp = new BufferedImage(2000, 2000, BufferedImage.TYPE_INT_ARGB);  
        //Graphics oG=layerTemp.getGraphics();       
        //oG.clearRect(0,0,2000,2000);
        //paintScreen(oG);     
        //echo ("s"+noDrawing);
        if (animator!=null && noDrawing==false){
            //echo ("sdf");
            drawScreen();
        }
    }

    public void saveImage(int x, int y, int width, int height)
    {
        DateFormat df = new SimpleDateFormat("MM-dd-yy HH-mm-ss");
        Date dateobj = new Date();        
        saveImage(x,y,width,height,new File(df.format(dateobj)+".png"));
    }

    public void saveImage(int x, int y, int width, int height,File file)
    {
        BufferedImage bImg = new BufferedImage(width,height, BufferedImage.TYPE_INT_RGB);
        Graphics bImgG = bImg.getGraphics();
        bImgG.drawImage(layerSet,-x,-y,this);
        bImgG.drawImage(layerTemp,-x,-y,this); 

        try {
            if (ImageIO.write(bImg, "png", file))
            {
                System.out.println("Saved image to "+ file.getName());
            }
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } 
    }    

    /*********************************************************************************************/
    /* BELOW IS FOR ANIMATION.  THE ONLY THING THAT YOU NEED TO CHANGE IS DELAY */

    public int frame;
    int delay=50;   // this is the time of the delay in milliseconds.
    Thread animator;

    public void setDelay(int ms)
    {
        delay=ms;
    }

    /**
     * This method is called when the applet becomes visible on
     * the screen. Create a thread and start it.
     */
    public void start()
    {
        animator = new Thread(this);
        if (isAnimation)
            animator.start();

    }

    /**
     * This method is called by the thread that was created in
     * the start method. It does the main animation.
     */
    public void run()
    {
        // Remember the starting time
        long tm = System.currentTimeMillis();
        while (Thread.currentThread() == animator)
        {
            // Display the next frame of animation.
            updateIt();
            try
            {
                tm += delay;
                Thread.sleep(Math.max(0, tm - System.currentTimeMillis()));
            }
            catch (InterruptedException e)
            {
                break;
            }
            // Advance the frame
            frame++;
        }
    }

    /**
     * This method is called when the applet is no longer
     * visible. Set the animator variable to null so that the
     * thread will exit before displaying the next frame.
     */
    public void stop()
    {
        animator = null;
    }

    public void echo(String s)
    {
        System.out.println(s);
    }

    public void echo(int s)
    {
        System.out.println(s);
    }

    public void echo(double s)
    {
        System.out.println(s);
    }

    public int readInt()
    {
        Scanner scan=new Scanner(System.in);
        try{
            return scan.nextInt();
        }
        catch (Exception e)
        {
            System.out.println("not an int");
            return -1;
        }
    }

    public double readDouble()
    {
        Scanner scan=new Scanner(System.in); 
        try{
            return scan.nextDouble();
        }
        catch (Exception e)
        {
            System.out.println("not an double");
            return -1;
        }
    }

    public String readString()
    {
        Scanner scan=new Scanner(System.in);
        try{
            return scan.nextLine();
        }
        catch (Exception e)
        {
            System.out.println("not an string?");
            return "";
        }
    }

    class ImagePanel extends JComponent {
        private Image image;
        int imgX=0;
        int imgY=0;
        double scale=1;
        public ImagePanel(String fileName) {
            try
            {
                image=javax.imageio.ImageIO.read(new java.io.File(fileName));
            }
            catch (Exception e){}
        }

        public ImagePanel(String fileName,double scale) {
            try
            {
                image=javax.imageio.ImageIO.read(new java.io.File(fileName));
                this.scale=scale;
            }
            
            catch (Exception e){}
        }        
        
        public ImagePanel(String fileName, int x, int y) {
            try
            {
                image=javax.imageio.ImageIO.read(new java.io.File(fileName));
                imgX=x;
                imgY=y;
            }
            catch (Exception e){}
        }        

        @Override
        protected void paintComponent(Graphics g) {
            g.setColor(backgroundColor);
            g.fillRect(0,0,2000,2000);            
             int w = image.getWidth(null);
            int h = image.getHeight(null);
            g.drawImage(image, imgX, imgY, (int)(w*scale),(int)(h*scale),null);    
            //oG.drawImage(img,x,y,(int)(w*scale),(int)(h*scale),null);
        }
    }    
}

