/**
Borlands Base code to get up and running quickly with Java and Applets
 */
import javax.swing.UIManager.LookAndFeelInfo;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.image.*;

public class BorlandBase extends BFrame
{
    private int width=500;
    private int height=500;    
    private boolean fullScreen=false;
    BPanel openPanel;
    Container screen;
    /**
     * Set the width of the program - 500 by default
     */
    public void setWidth(int w)
    {
        width=w;    
    }

    /**
     * Set the height of the program - 500 by default
     */
    public void setHeight(int h)
    {
        height=h;
    }

    /**
     * Set animation to true or false - false by default
     */
    public void setAnimation(boolean animate)
    {
        isAnimation=animate;
    }

    /**
     * If you want it to be near fullscreen
     */    
    public void setFullScreen()
    {
        fullScreen=true;
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        width=screenSize.width-50;
        height=screenSize.height-50;   
    }

    public void restoreContentPane(){
        setContentPane(screen);
    }
    
    public void openPanel(BPanel thePanel, boolean animate){
        openPanel=thePanel;
        openPanel.init();
        //openPanel.setPreferredSize(new Dimension(400,400));
       // openPanel.setHeight(400);
        openPanel.setMainFrame(this);
        openPanel.setAnimation(animate);
        openPanel.setPreferredSize(getSize());
        screen=getContentPane();
       // screen.setLayout(new FlowLayout());
        setContentPane(openPanel);
      // setOpaque(true);
        // super.paint(getGraphics());
        pack();
         revalidate();
         
          openPanel.repaint();
         // screen.setBackground(Color.red);
          //setBackground(Color.red);
    }
    
    
    
    /**
     * DONT CALL THIS - A HELPER METHOD
     */
    public static void main(BorlandBase a) {
        //BorlandBase a = new BorlandBase();
        // System.setProperty("swing.defaultlaf", "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
        try {
            for (LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (Exception e) {
            // If Nimbus is not available, you can set the GUI to another look and feel.
        }
        a.init();
       
        //JFrame j=new JFrame();        
        a.setSize(a.width,a.height);
        a.setVisible(true);
        a.setResizable(true);       
        a.start();

    }

}
